
/******************************************************************************
*
*   FILE
*   ----
*   CONCATVEC.c
*
*   History
*   -------
*   2012-11-14   File created
*
*******************************************************************************
*
*   This file is generated by the 'acplt_builder' command
*
******************************************************************************/


#ifndef OV_COMPILE_LIBRARY_iec61131stdfb
#define OV_COMPILE_LIBRARY_iec61131stdfb
#endif


#include "iec61131stdfb.h"
#include "libov/ov_macros.h"
#include "libov/ov_result.h"
#include "libov/ov_logfile.h"
#include "helper.h"


OV_DLLFNCEXPORT OV_RESULT iec61131stdfb_CONCATVEC_IN1_set(
    OV_INSTPTR_iec61131stdfb_CONCATVEC          pobj,
    const OV_ANY*  value
) {
	if(((value->value.vartype & OV_VT_KSMASK) & (!OV_VT_ISVECTOR)) == ((pobj->v_IN1.value.vartype & OV_VT_KSMASK) & (!OV_VT_ISVECTOR)))
		return ov_variable_setanyvalue(&pobj->v_IN1, value);
	else
	{

		if (iec61131stdfb_isConnected (Ov_PtrUpCast (fb_functionblock, pobj)))
			return OV_ERR_NOACCESS;

		iec61131stdfb_freeVec(&pobj->v_IN1);
		iec61131stdfb_freeVec(&pobj->v_IN2);
		iec61131stdfb_freeVec(&pobj->v_OUT);		//free memory of preexisting out-vector

		pobj->v_IN2.value.vartype = value->value.vartype;
		pobj->v_OUT.value.vartype = value->value.vartype | OV_VT_ISVECTOR;
	}
	return ov_variable_setanyvalue(&pobj->v_IN1, value);
}

OV_DLLFNCEXPORT OV_RESULT iec61131stdfb_CONCATVEC_IN2_set(
    OV_INSTPTR_iec61131stdfb_CONCATVEC          pobj,
    const OV_ANY*  value
) {
	if((value->value.vartype & OV_VT_KSMASK & (!OV_VT_ISVECTOR)) == (pobj->v_IN2.value.vartype & OV_VT_KSMASK & (!OV_VT_ISVECTOR)))
		return ov_variable_setanyvalue(&pobj->v_IN2, value);
	else
	{

		if (iec61131stdfb_isConnected (Ov_PtrUpCast (fb_functionblock, pobj)))
			return OV_ERR_NOACCESS;

		iec61131stdfb_freeVec(&pobj->v_IN1);
		iec61131stdfb_freeVec(&pobj->v_IN2);
		iec61131stdfb_freeVec(&pobj->v_OUT);		//free memory of preexisting out-vector

		pobj->v_IN1.value.vartype = value->value.vartype;
		pobj->v_OUT.value.vartype = value->value.vartype | OV_VT_ISVECTOR;
	}
	return ov_variable_setanyvalue(&pobj->v_IN1, value);
}

OV_DLLFNCEXPORT OV_ANY* iec61131stdfb_CONCATVEC_OUT_get(
    OV_INSTPTR_iec61131stdfb_CONCATVEC          pobj
) {
    return &pobj->v_OUT;
}

OV_DLLFNCEXPORT void iec61131stdfb_CONCATVEC_destructor(
	OV_INSTPTR_ov_object 	pobj
) {
    /*    
    *   local variables
    */
    OV_INSTPTR_iec61131stdfb_CONCATVEC pinst = Ov_StaticPtrCast(iec61131stdfb_CONCATVEC, pobj);

    /* do what */
    iec61131stdfb_freeVec(&pinst->v_IN1);
    iec61131stdfb_freeVec(&pinst->v_IN2);
    iec61131stdfb_freeVec(&pinst->v_OUT);
    /* destroy object */
    fb_functionblock_destructor(pobj);

    return;
}

OV_DLLFNCEXPORT OV_RESULT iec61131stdfb_CONCATVEC_constructor(OV_INSTPTR_ov_object pobj) {

	OV_RESULT res;
	OV_INSTPTR_iec61131stdfb_CONCATVEC pinst = Ov_StaticPtrCast(iec61131stdfb_CONCATVEC, pobj);
	OV_SINGLE temp [2];
	OV_SINGLE_VEC vtemp;
	temp [0] = 0;
	temp [1] = 1;
	vtemp.value = temp;
	vtemp.veclen = 2;
	res = fb_functionblock_constructor(pobj);
	if(Ov_OK(res))
	{
		pinst->v_IN1.value.valueunion.val_double = 0;
		pinst->v_IN2.value.valueunion.val_double = 0;
		pinst->v_OUT.value.valueunion.val_double = 0;
		pinst->v_IN1.value.vartype = OV_VT_SINGLE;
		pinst->v_IN2.value.vartype = OV_VT_SINGLE;
		pinst->v_OUT.value.vartype = OV_VT_SINGLE_VEC;
		Ov_SetDynamicVectorValue(&(pinst->v_OUT.value.valueunion.val_single_vec), &vtemp, 2, SINGLE);

		return OV_ERR_OK;
	}
	else
		return res;
}

/**************************************************************
 * Helper-Macro for concatination
 */

#define HLP_CONCAT(TYPE, type) \
	case OV_VT_##TYPE##_VEC:	\
    	if(!(pinst->v_IN1.value.vartype & OV_VT_ISVECTOR))	\
    		in1length = 1;	\
    	else	\
    		in1length = pinst->v_IN1.value.valueunion.val_##type##_vec.veclen;	\
    	if(!(pinst->v_IN2.value.vartype & OV_VT_ISVECTOR))	\
    		in2length = 1;	\
    	else	\
    		in2length = pinst->v_IN2.value.valueunion.val_##type##_vec.veclen;	\
    	result = Ov_SetDynamicVectorLength(&pinst->v_OUT.value.valueunion.val_##type##_vec, in1length+in2length, TYPE);	\
    	if(Ov_Fail(result))	\
    	{	\
    		ov_logfile_error("%s: Setting OUT-Vector length to %d failed. Code: %s", pinst->v_identifier, in1length+in2length, ov_result_getresulttext(result));	\
    		return;	\
    	}	\
    	if(in1length)	\
    	{	\
    		if(!(pinst->v_IN1.value.vartype & OV_VT_ISVECTOR))	\
    		{	\
    			pinst->v_OUT.value.valueunion.val_##type##_vec.value[0] = pinst->v_IN1.value.valueunion.val_##type;	\
    			copieditems = 1;	\
    		}	\
    		else	\
    		{	\
    			for(i=0; i<in1length; i++)	\
    				pinst->v_OUT.value.valueunion.val_##type##_vec.value[i] = pinst->v_IN1.value.valueunion.val_##type##_vec.value[i];	\
    			copieditems = in1length;	\
    		}	\
    	}	\
    	if(in2length)	\
    	{	\
    		if(!(pinst->v_IN2.value.vartype & OV_VT_ISVECTOR))	\
    		{	\
    			pinst->v_OUT.value.valueunion.val_##type##_vec.value[copieditems] = pinst->v_IN2.value.valueunion.val_##type;	\
    		}	\
    		else	\
    		{	\
    			for(i=0; i<in2length; i++)	\
    				pinst->v_OUT.value.valueunion.val_##type##_vec.value[copieditems+i] = pinst->v_IN1.value.valueunion.val_##type##_vec.value[i];	\
    		}	\
    	}	\
    	break



OV_DLLFNCEXPORT void iec61131stdfb_CONCATVEC_typemethod(
	OV_INSTPTR_fb_functionblock	pfb,
	OV_TIME						*pltc
) {
    /*    
    *   local variables
    */
    OV_INSTPTR_iec61131stdfb_CONCATVEC pinst = Ov_StaticPtrCast(iec61131stdfb_CONCATVEC, pfb);
    OV_UINT in1length, in2length = 0;
    OV_UINT copieditems = 0;
    OV_UINT i;
    OV_RESULT result;

    if((((pinst->v_IN1.value.vartype & OV_VT_KSMASK) & (!OV_VT_ISVECTOR)) != ((pinst->v_OUT.value.vartype & OV_VT_KSMASK) & (!OV_VT_ISVECTOR)))
    	|| (((pinst->v_IN2.value.vartype & OV_VT_KSMASK) & (!OV_VT_ISVECTOR)) != ((pinst->v_OUT.value.vartype & OV_VT_KSMASK) & (!OV_VT_ISVECTOR)))
    	|| (!pinst->v_OUT.value.vartype & (!OV_VT_ISVECTOR)))
    {
    	ov_logfile_error("Types of INs and OUT don't match. [weird]");
    	return;
    }

    switch(pinst->v_OUT.value.vartype & OV_VT_KSMASK)
    {
    HLP_CONCAT(UINT, uint);
	HLP_CONCAT(INT, int);
	HLP_CONCAT(SINGLE, single);
	HLP_CONCAT(DOUBLE, double);
	HLP_CONCAT(BOOL, bool);
	HLP_CONCAT(BYTE, byte);
	HLP_CONCAT(TIME, time);
	HLP_CONCAT(TIME_SPAN, time_span);

    case OV_VT_STRING_VEC:
        	if(!(pinst->v_IN1.value.vartype & OV_VT_ISVECTOR))
        		in1length = 1;
        	else
        		in1length = pinst->v_IN1.value.valueunion.val_string_vec.veclen;
        	if(!(pinst->v_IN2.value.vartype & OV_VT_ISVECTOR))
        		in2length = 1;
        	else
        		in2length = pinst->v_IN2.value.valueunion.val_string_vec.veclen;
        	result = Ov_SetDynamicVectorLength(&pinst->v_OUT.value.valueunion.val_string_vec, in1length+in2length, STRING);

        	if(Ov_Fail(result))
        	{
        		ov_logfile_error("%s: Setting OUT-Vector length to %d failed. Code: %s", pinst->v_identifier, in1length+in2length, ov_result_getresulttext(result));
        		return;
        	}

        	if(in1length)
        	{
        		if(!(pinst->v_IN1.value.vartype & OV_VT_ISVECTOR))
        		{
        			result = ov_string_setvalue(&(pinst->v_OUT.value.valueunion.val_string_vec.value[0]), pinst->v_IN1.value.valueunion.val_string);
        			if(Ov_Fail(result))
        			{
        				ov_logfile_error("%s: Setting string in OUT-Vector element %d failed. Code: %s", pinst->v_identifier, copieditems + 1, ov_result_getresulttext(result));
        				return;
        			}
        			copieditems = 1;
        		}
        		else
        		{
        			for(i=0; i<in1length; i++)
        			{
        				result = ov_string_setvalue(&(pinst->v_OUT.value.valueunion.val_string_vec.value[i]), pinst->v_IN1.value.valueunion.val_string_vec.value[i]);
        				if(Ov_Fail(result))
        				{
        					ov_logfile_error("%s: Setting string in OUT-Vector element %d failed. Code: %s", pinst->v_identifier, copieditems + 1, ov_result_getresulttext(result));
        					return;
        				}
        			}
        			copieditems = in1length;
        		}
        	}
        	if(in2length)
        	{
        		if(!(pinst->v_IN2.value.vartype & OV_VT_ISVECTOR))
        		{
        			result = ov_string_setvalue(&(pinst->v_OUT.value.valueunion.val_string_vec.value[copieditems]), pinst->v_IN2.value.valueunion.val_string);
        			if(Ov_Fail(result))
        			{
        				ov_logfile_error("%s: Setting string in OUT-Vector element %d failed. Code: %s", pinst->v_identifier, copieditems, ov_result_getresulttext(result));
        				return;
        			}
        		}
        		else
        		{
        			for(i=0; i<in1length; i++)
        			{
        				result = ov_string_setvalue(&(pinst->v_OUT.value.valueunion.val_string_vec.value[i + copieditems]), pinst->v_IN2.value.valueunion.val_string_vec.value[i]);
        				if(Ov_Fail(result))
        				{
        					ov_logfile_error("%s: Setting string in OUT-Vector element %d failed. Code: %s", pinst->v_identifier, copieditems + 1, ov_result_getresulttext(result));
        					return;
        				}
        			}
        		}
        	}
        	break;

    default:
    	ov_logfile_error("Type not implemented. [weird]");
    	break;
    }

    return;
}

