/*
*	Copyright (C) 2010
*	Chair of Process Control Engineering,
*	Aachen University of Technology.
*	All rights reserved.
*
*	Redistribution and use in source and binary forms, with or without
*	modification, are permitted provided that the following conditions
*	are met:
*	1. Redistributions of source code must retain the above copyright
*	   notice, this list of conditions and the following disclaimer.
*	2. Redistributions in binary form must print or display the above
*	   copyright notice either during startup or must have a means for
*	   the user to view the copyright notice.
*	3. Redistributions in binary form must reproduce the above copyright
*	   notice, this list of conditions and the following disclaimer in
*		the documentation and/or other materials provided with the
*		distribution.
*	4. Neither the name of the Chair of Process Control Engineering nor
*		the name of the Aachen University of Technology may be used to
*		endorse or promote products derived from this software without
*		specific prior written permission.
*
*	THIS SOFTWARE IS PROVIDED BY THE CHAIR OF PROCESS CONTROL ENGINEERING
*	``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
*	LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
*	A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE CHAIR OF
*	PROCESS CONTROL ENGINEERING BE LIABLE FOR ANY DIRECT, INDIRECT,
*	INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
*	BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
*	OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
*	AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
*	LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY
*	WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
*	POSSIBILITY OF SUCH DAMAGE.
*/
/******************************************************************************
*
*   FILE
*   ----
*   NE.c
*
*   History
*   -------
*   2010-11-30   File created
*
*******************************************************************************
*
*   This file is generated by the 'fb_builder' command
*
******************************************************************************/


#ifndef OV_COMPILE_LIBRARY_iec61131stdfb
#define OV_COMPILE_LIBRARY_iec61131stdfb
#endif


#include "iec61131stdfb.h"
#include "stdfb_macros.h"
#include "libov/ov_macros.h"
#include "libov/ov_logfile.h"
#include "helper.h"


OV_RESULT
iec61131stdfb_NE_setType
(OV_INSTPTR_iec61131stdfb_NE pobj, OV_VAR_TYPE type)
{
  if (iec61131stdfb_isConnected (Ov_PtrUpCast (fb_functionblock, pobj)))
    return OV_ERR_NOACCESS;
  else
  {
    
    switch(type & OV_VT_KSMASK)
	{
		case OV_VT_BOOL:
		case OV_VT_INT:
		case OV_VT_UINT:
		case OV_VT_BYTE:
		case OV_VT_SINGLE:
		case OV_VT_DOUBLE:
		case OV_VT_STRING:
		case OV_VT_TIME:
		case OV_VT_TIME_SPAN:
		case OV_VT_BOOL_VEC:
		case OV_VT_INT_VEC:
		case OV_VT_UINT_VEC:
		case OV_VT_BYTE_VEC:
		case OV_VT_SINGLE_VEC:
		case OV_VT_DOUBLE_VEC:
		case OV_VT_STRING_VEC:
		case OV_VT_TIME_VEC:
		case OV_VT_TIME_SPAN_VEC:
			pobj->v_IN1.value.vartype = type;
			pobj->v_IN2.value.vartype = type;
			return OV_ERR_OK;
		default:
			return OV_ERR_BADPARAM;
	}
		return OV_ERR_GENERIC;
  }
}


OV_DLLFNCEXPORT OV_RESULT iec61131stdfb_NE_IN1_set(
    OV_INSTPTR_iec61131stdfb_NE          pobj,
    const OV_ANY*  value
) {
    OV_RESULT res;
  
	  if ((value->value.vartype & OV_VT_KSMASK) == (pobj->v_IN1.value.vartype & OV_VT_KSMASK))
		return ov_variable_setanyvalue (&pobj->v_IN1, value);
	  else
	  {
		iec61131stdfb_freeVec(&pobj->v_IN1);
		iec61131stdfb_freeVec(&pobj->v_IN2);
		res = iec61131stdfb_NE_setType (pobj, value->value.vartype); 
		if (Ov_OK (res))
		  return ov_variable_setanyvalue (&pobj->v_IN1, value);
		else return res;
	  }
}

OV_DLLFNCEXPORT OV_RESULT iec61131stdfb_NE_IN2_set(
    OV_INSTPTR_iec61131stdfb_NE          pobj,
    const OV_ANY*  value
) {
    OV_RESULT res;
  
	  if ((value->value.vartype & OV_VT_KSMASK) == (pobj->v_IN2.value.vartype & OV_VT_KSMASK))
		return ov_variable_setanyvalue (&pobj->v_IN2, value);
	  else
	  {
		iec61131stdfb_freeVec(&pobj->v_IN1);
		iec61131stdfb_freeVec(&pobj->v_IN2);
		res = iec61131stdfb_NE_setType (pobj, value->value.vartype); 
		if (Ov_OK (res))
		  return ov_variable_setanyvalue (&pobj->v_IN2, value);
		else return res;
	  }
}

OV_DLLFNCEXPORT OV_BOOL iec61131stdfb_NE_OUT_get(
    OV_INSTPTR_iec61131stdfb_NE          pobj
) {
    return pobj->v_OUT;
}


OV_DLLFNCEXPORT void iec61131stdfb_NE_destructor(OV_INSTPTR_ov_object pobj) {

	OV_INSTPTR_iec61131stdfb_NE pinst = Ov_StaticPtrCast(iec61131stdfb_NE, pobj);
	
	iec61131stdfb_freeVec(&pinst->v_IN1);
	iec61131stdfb_freeVec(&pinst->v_IN2);
	fb_functionblock_destructor(pobj);
}


OV_DLLFNCEXPORT OV_RESULT iec61131stdfb_NE_constructor(OV_INSTPTR_ov_object pobj) {

	OV_RESULT res;
	OV_INSTPTR_iec61131stdfb_NE pinst = Ov_StaticPtrCast(iec61131stdfb_NE, pobj);
	
	res = fb_functionblock_constructor(pobj);
	if(Ov_OK(res))
	{
		pinst->v_IN1.value.valueunion.val_double = 0;
		pinst->v_IN2.value.valueunion.val_double = 0;
		pinst->v_IN1.value.vartype = OV_VT_SINGLE;
		pinst->v_IN2.value.vartype = OV_VT_SINGLE;
		return OV_ERR_OK;
	}
	else
		return res;
}


OV_DLLFNCEXPORT void iec61131stdfb_NE_typemethod(
	OV_INSTPTR_fb_functionblock	pfb,
	OV_TIME						*pltc
) {
    /*    
    *   local variables
    */
    OV_INSTPTR_iec61131stdfb_NE pinst = Ov_StaticPtrCast(iec61131stdfb_NE, pfb);
	
	if(!(pinst->v_IN1.value.vartype & OV_VT_ISVECTOR))
	{
		switch(pinst->v_IN1.value.vartype & OV_VT_KSMASK)
		{
			STDFB_NE(BOOL, bool);
			STDFB_NE(BYTE, byte);
			STDFB_NE(UINT, uint);
			STDFB_NE(INT, int);
			STDFB_NE(SINGLE, single);
			STDFB_NE(DOUBLE, double);
			
			case OV_VT_STRING:
				if(ov_string_compare(pinst->v_IN1.value.valueunion.val_string, pinst->v_IN2.value.valueunion.val_string) != 0)
					pinst->v_OUT = TRUE;
				else
					pinst->v_OUT = FALSE;
			break;
			
			case OV_VT_TIME:
				if(STDFB_NE_TIME(pinst->v_IN1.value.valueunion.val_time, pinst->v_IN2.value.valueunion.val_time))
					pinst->v_OUT = TRUE;
				else
					pinst->v_OUT = FALSE;
					
			break;
			
			case OV_VT_TIME_SPAN:
				if(STDFB_NE_TIME(pinst->v_IN1.value.valueunion.val_time_span, pinst->v_IN2.value.valueunion.val_time_span))
					pinst->v_OUT = TRUE;
				else
					pinst->v_OUT = FALSE;
			break;
			
			default:
				ov_logfile_error("%s: comparison of given datatype not implemented", pinst->v_identifier);
				pinst->v_OUT = FALSE;
				return;
		}
	}
	else
	{
		ov_logfile_warning("%s: comparison of vectors concerns their length only", pinst->v_identifier);
		switch(pinst->v_IN1.value.vartype & OV_VT_KSMASK)
		{
			STDFB_NE_VEC(BOOL, bool);
			STDFB_NE_VEC(BYTE, byte);
			STDFB_NE_VEC(UINT, uint);
			STDFB_NE_VEC(INT, int);
			STDFB_NE_VEC(SINGLE, single);
			STDFB_NE_VEC(DOUBLE, double);
			STDFB_NE_VEC(STRING, string);
			STDFB_NE_VEC(TIME, time);
			STDFB_NE_VEC(TIME_SPAN, time_span);
			
			default:
					ov_logfile_error("%s: comparison of given datatype not implemented", pinst->v_identifier);
					pinst->v_OUT = FALSE;
					return;
		}
	}
		
		//implement status and timestamp here
	
    return;
}

