/*
*   $Id: ov_version.h,v 1.42 2011-01-18 14:27:34 martin Exp $
*
*   Copyright (C) 1998-2006
*   Lehrstuhl fuer Prozessleittechnik,
*   RWTH Aachen, D-52056 Aachen, Germany.
*   All rights reserved.
*
*   Author: Dirk Meyer <dirk@plt.rwth-aachen.de>
*
*   This file is part of the ACPLT/OV Package which is licensed as open
*   source under the Artistic License; you can use, redistribute and/or
*   modify it under the terms of that license.
*
*   You should have received a copy of the Artistic License along with
*   this Package; see the file ARTISTIC-LICENSE. If not, write to the
*   Copyright Holder.
*
*   THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
*   WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES
*   OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*/
/*
*	History:
*	--------
*	13-Jan-1999 Dirk Meyer <dirk@plt.rwth-aachen.de>: File created.
*	08-Apr-1999 Dirk Meyer <dirk@plt.rwth-aachen.de>: Major revision.
*/

#ifndef OV_VERSION_H_INCLUDED
#define OV_VERSION_H_INCLUDED

/*
*	Version information for different modules of ACPLT/OV
*	-----------------------------------------------------
*/
#define OV_VER_CODEGEN						"1.6.4"
#define OV_VER_BUILDER 						"1.0.4"
#define OV_VER_MAKMAK 						"1.0.1"
#define OV_VER_DBDUMP 						"1.3.6"
#define OV_VER_DBPARSE						"1.1.8"
#define OV_VER_OVXIPARSE					"1.0.2"
#define OV_VER_LIBINFO 						"1.0.0"
#define OV_VER_LIBOV						"2.0.0"
#define OV_VER_DBUTIL 						"1.2.1"
#define OV_VER_LIBOVKS 						"1.2.5"
#define OV_VER_SERVER						"1.3.2"
#define OV_VER_NTSERVICE					"1.3.1"
#define OV_VER_CONTROLPANEL					"1.2.0"

#define OV_VER_FILEVERSION_CODEGEN			1, 6, 4, 0
#define OV_VER_FILEVERSION_BUILDER			1, 0, 4, 0
#define OV_VER_FILEVERSION_MAKMAK			1, 0, 1, 0
#define OV_VER_FILEVERSION_DBDUMP			1, 3, 6, 0
#define OV_VER_FILEVERSION_DBPARSE			1, 1, 8, 0
#define OV_VER_FILEVERSION_OVXIPARSE		1, 0, 2, 0
#define OV_VER_FILEVERSION_LIBINFO			1, 0, 0, 0
#define OV_VER_FILEVERSION_LIBOV			2, 0, 0, 0
#define OV_VER_FILEVERSION_DBUTIL 			1, 2, 1, 0
#define OV_VER_FILEVERSION_LIBOVKS 			1, 3, 4, 0
#define OV_VER_FILEVERSION_SERVER			1, 3, 2, 0
#define OV_VER_FILEVERSION_NTSERVICE		1, 3, 1, 0
#define OV_VER_FILEVERSION_CONTROLPANEL		1, 2, 0, 0

#define OV_VER_PRODUCTVERSION_CODEGEN			1, 6, 7, 0
#define OV_VER_PRODUCTVERSION_BUILDER			1, 6, 7, 0
#define OV_VER_PRODUCTVERSION_MAKMAK			1, 6, 7, 0
#define OV_VER_PRODUCTVERSION_DBDUMP			1, 6, 7, 0
#define OV_VER_PRODUCTVERSION_DBPARSE			1, 6, 7, 0
#define OV_VER_PRODUCTVERSION_OVXIPARSE			1, 6, 7, 0
#define OV_VER_PRODUCTVERSION_LIBINFO			1, 6, 7, 0
#define OV_VER_PRODUCTVERSION_LIBOV				2, 0, 0, 0
#define OV_VER_PRODUCTVERSION_DBUTIL 			1, 6, 7, 0
#define OV_VER_PRODUCTVERSION_LIBOVKS 			1, 6, 7, 0
#define OV_VER_PRODUCTVERSION_SERVER			1, 6, 7, 0
#define OV_VER_PRODUCTVERSION_NTSERVICE			1, 6, 7, 0
#define OV_VER_PRODUCTVERSION_CONTROLPANEL		1, 6, 7, 0

#define OV_VER_LEGALCOPYRIGHT "Copyright  PLT 1998-2014"
#define OV_VER_PRODUCTNAME "ACPLT runtime environment"
#define OV_VER_COMPANYNAME "Lehrstuhl fuer Prozessleittechnik, RWTH Aachen, D-52056 Aachen, Germany"

#define OV_VER_LICENSE															\
	OV_VER_LEGALCOPYRIGHT 														\
	"Lehrstuhl fuer Prozessleittechnik, "										\
	"RWTH Aachen, D-52056 Aachen, Germany. "									\
	"All rights reserved.\r\n"													\
	"\r\n"																		\
	"This file is part of the ACPLT/OV Package which is licensed as open "		\
	"source under the Artistic License; you can use, redistribute and/or "		\
	"modify it under the terms of that license.\r\n"							\
	"\r\n"																		\
	"You should have received a copy of the Artistic License along with "		\
	"this Package; see the file ARTISTIC-LICENSE. If not, write to the "		\
	"Copyright Holder.\r\n"														\
	"\r\n"																		\
	"THIS PACKAGE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED "	\
	"WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES "		\
	"OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.\r\n"

#endif
/*
*	End of file
*/

