
/******************************************************************************
 *
 *   FILE
 *   ----
 *   functionchart.c
 *
 *   History
 *   -------
 *   2011-06-10   File created
 *
 *******************************************************************************
 *
 *   This file is generated by the 'fb_builder' command
 *
 ******************************************************************************/


#ifndef OV_COMPILE_LIBRARY_fb
#define OV_COMPILE_LIBRARY_fb
#endif


#include "fb.h"
#include "libov/ov_macros.h"
#include "fb_namedef.h"
#include "fb_macros.h"
#include "ov_call_macros_10.h"

/*
 *	Execute internal task
 */
void fbchart_execIntask(
		OV_INSTPTR_fb_task	pIntask,
		OV_TIME				*pltc
) {
	OV_VTBLPTR_fb_task	             pvtable;


	Ov_GetVTablePtr(fb_task, pvtable, pIntask);

	if(!pvtable) {
		/* ? */
		return;
	}
	pvtable->m_execute(pIntask, pltc);
}

/*
 *	Typemethod of functionchart
 */
OV_DLLFNCEXPORT void fb_functionchart_typemethod(
		OV_INSTPTR_fb_functionblock  pfb,
		OV_TIME                     *pltc
) {
	OV_INSTPTR_fb_functionchart pfc = Ov_StaticPtrCast(fb_functionchart, pfb);
	OV_INSTPTR_fb_task          intask = Ov_GetPartPtr(intask, pfc);

	/* Init intask */
	intask->v_actimode = FB_AM_ON;
	intask->v_cyctime.secs = 0;
	intask->v_cyctime.usecs = 0;
	intask->v_proctime = *pltc;

	/* Trigger all connections on chart input ports */
	fb_object_triggerInpGetConnections(Ov_PtrUpCast(fb_object, pfb));

	/* Execute internal task */
	fbchart_execIntask(intask, pltc);

	/* Trigger all connections on chart output ports */
	fb_object_triggerOutSendConnections(Ov_PtrUpCast(fb_object, pfb));
}

/**
 * Searches for a port of an FC by port's name
 *
 * @param pfc pointer to the FC
 * @param id of port to search
 * @return pointer to the found port of NULL
 */
static OV_INSTPTR_fb_port fb_functionchart_searchport
(OV_INSTPTR_fb_functionchart pfc,
		OV_STRING id
)
{
	OV_INSTPTR_fb_port pvar;

	Ov_ForEachChild (fb_variables, pfc, pvar)
	{
		if (ov_string_compare (id, pvar->v_identifier) == OV_STRCMP_EQUAL)
		{
			return pvar;
		}
	}

	return NULL;
}

/**
 * Auxiliary static function for fb_functionchart_setport and _getport
 *
 * @param pfc pointer to the FC
 * @param varname name of the port to get/set
 * @param pvarcurrprops value to get/set
 * @return standard error code
 */
static OV_RESULT fb_functionchart_getorsetport
(OV_INSTPTR_fb_functionchart pfc,
		const OV_STRING varname,
		OV_ANY *pvarcurrprops,
		OV_BOOL getorset)
{
	OV_ELEMENT objelem, varelem;
	OV_INSTPTR_fb_port pvar;
	OV_STRING varid;


	if ((pvar = fb_functionchart_searchport(pfc, varname))) {
		objelem.pobj = Ov_PtrUpCast (ov_object, pvar);
		varid = "value";
	} else {
		objelem.pobj = Ov_PtrUpCast (ov_object, pfc);
		varid = varname;
	}
	objelem.elemtype = OV_ET_OBJECT;
	if (Ov_OK(ov_element_searchpart(&objelem, &varelem, OV_ET_VARIABLE, varid)) && varelem.pobj!=NULL) {
		if (getorset) {
			return Ov_Call2 (ov_object, objelem.pobj, getvar, &varelem, pvarcurrprops);
		} else {
			return Ov_Call2 (ov_object, objelem.pobj, setvar, &varelem, pvarcurrprops);
		}
	}else{
		return OV_ERR_BADPARAM;
	}
}

/**
 * Sets dynamic port of an FC or its internal variable if port not found
 *
 * @param pfc pointer to the FC
 * @param varname name of the port to set
 * @param pvarcurrprops value to set
 * @return standard error code
 */
OV_DLLFNCEXPORT OV_RESULT fb_functionchart_setport(
		OV_INSTPTR_fb_functionchart     pfc,
		const OV_STRING varname,
		OV_ANY *pvarcurrprops
) {
	return fb_functionchart_getorsetport(pfc, varname, pvarcurrprops, FALSE);
}

/**
 * Gets dynamic port of an FC or its internal variable if port not found
 *
 * @param pfc pointer to the FC
 * @param varname name of the port to set
 * @param pvarcurrprops value to save the value
 * @return standard error code
 */
OV_DLLFNCEXPORT OV_RESULT fb_functionchart_getport(
		OV_INSTPTR_fb_functionchart     pfc,
		const OV_STRING varname,
		OV_ANY *pvarcurrprops
) {
	return fb_functionchart_getorsetport(pfc, varname, pvarcurrprops, TRUE);
}
